EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TAGS_EVENT_ITEM_SELECTED =
   EFL_EVENT_DESCRIPTION("item,selected");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TAGS_EVENT_ITEM_ADDED =
   EFL_EVENT_DESCRIPTION("item,added");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TAGS_EVENT_ITEM_DELETED =
   EFL_EVENT_DESCRIPTION("item,deleted");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TAGS_EVENT_ITEM_CLICKED =
   EFL_EVENT_DESCRIPTION("item,clicked");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TAGS_EVENT_ITEM_LONGPRESSED =
   EFL_EVENT_DESCRIPTION("item,longpressed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TAGS_EVENT_EXPANDED =
   EFL_EVENT_DESCRIPTION("expanded");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TAGS_EVENT_CONTRACTED =
   EFL_EVENT_DESCRIPTION("contracted");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TAGS_EVENT_EXPAND_STATE_CHANGED =
   EFL_EVENT_DESCRIPTION("expand,state,changed");

void _efl_ui_tags_editable_set(Eo *obj, Efl_Ui_Tags_Data *pd, Eina_Bool editable);


static Eina_Error
__eolian_efl_ui_tags_editable_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_tags_editable_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_tags_editable_set, EFL_FUNC_CALL(editable), Eina_Bool editable);

Eina_Bool _efl_ui_tags_editable_get(const Eo *obj, Efl_Ui_Tags_Data *pd);


static Eina_Value
__eolian_efl_ui_tags_editable_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_tags_editable_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_tags_editable_get, Eina_Bool, 0);

void _efl_ui_tags_expanded_set(Eo *obj, Efl_Ui_Tags_Data *pd, Eina_Bool expanded);


static Eina_Error
__eolian_efl_ui_tags_expanded_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_tags_expanded_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_tags_expanded_set, EFL_FUNC_CALL(expanded), Eina_Bool expanded);

Eina_Bool _efl_ui_tags_expanded_get(const Eo *obj, Efl_Ui_Tags_Data *pd);


static Eina_Value
__eolian_efl_ui_tags_expanded_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_tags_expanded_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_tags_expanded_get, Eina_Bool, 0);

void _efl_ui_tags_items_set(Eo *obj, Efl_Ui_Tags_Data *pd, const Eina_Array *items);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_tags_items_set, EFL_FUNC_CALL(items), const Eina_Array *items);

const Eina_Array *_efl_ui_tags_items_get(const Eo *obj, Efl_Ui_Tags_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_tags_items_get, const Eina_Array *, NULL);

Efl_Object *_efl_ui_tags_efl_object_constructor(Eo *obj, Efl_Ui_Tags_Data *pd);


void _efl_ui_tags_efl_object_destructor(Eo *obj, Efl_Ui_Tags_Data *pd);


Eina_Bool _efl_ui_tags_efl_ui_widget_widget_input_event_handler(Eo *obj, Efl_Ui_Tags_Data *pd, const Efl_Event *eo_event, Efl_Canvas_Object *source);


void _efl_ui_tags_efl_text_text_set(Eo *obj, Efl_Ui_Tags_Data *pd, const char *text);


const char *_efl_ui_tags_efl_text_text_get(const Eo *obj, Efl_Ui_Tags_Data *pd);


void _efl_ui_tags_efl_ui_format_apply_formatted_value(Eo *obj, Efl_Ui_Tags_Data *pd);


static Eina_Bool
_efl_ui_tags_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_TAGS_EXTRA_OPS
#define EFL_UI_TAGS_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_tags_editable_set, _efl_ui_tags_editable_set),
      EFL_OBJECT_OP_FUNC(efl_ui_tags_editable_get, _efl_ui_tags_editable_get),
      EFL_OBJECT_OP_FUNC(efl_ui_tags_expanded_set, _efl_ui_tags_expanded_set),
      EFL_OBJECT_OP_FUNC(efl_ui_tags_expanded_get, _efl_ui_tags_expanded_get),
      EFL_OBJECT_OP_FUNC(efl_ui_tags_items_set, _efl_ui_tags_items_set),
      EFL_OBJECT_OP_FUNC(efl_ui_tags_items_get, _efl_ui_tags_items_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_tags_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_ui_tags_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_input_event_handler, _efl_ui_tags_efl_ui_widget_widget_input_event_handler),
      EFL_OBJECT_OP_FUNC(efl_text_set, _efl_ui_tags_efl_text_text_set),
      EFL_OBJECT_OP_FUNC(efl_text_get, _efl_ui_tags_efl_text_text_get),
      EFL_OBJECT_OP_FUNC(efl_ui_format_apply_formatted_value, _efl_ui_tags_efl_ui_format_apply_formatted_value),
      EFL_UI_TAGS_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"editable", __eolian_efl_ui_tags_editable_set_reflect, __eolian_efl_ui_tags_editable_get_reflect},
      {"expanded", __eolian_efl_ui_tags_expanded_set_reflect, __eolian_efl_ui_tags_expanded_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_tags_class_desc = {
   EO_VERSION,
   "Efl.Ui.Tags",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Tags_Data),
   _efl_ui_tags_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_tags_class_get, &_efl_ui_tags_class_desc, EFL_UI_LAYOUT_BASE_CLASS, EFL_UI_FORMAT_MIXIN, EFL_TEXT_INTERFACE, NULL);
